unit IRCSystemBotInterface;

{
  IRCSystemBotInterface unit
  (c) 9-7-2001
}

interface

uses
  Windows;

const
  // Bot Options
  BOTOPT_OPERATOR = 1;
  BOTOPT_VISIBLE  = 2;

type
  // Message structure
  PIRCBotMessage = ^TIRCBotMessage;
  TIRCBotMessage = record
    size             : integer;
    Name             : PChar;
    User             : PChar;
    Host             : PChar;
    Command          : PChar;
    Params           : PChar;
    IsNumericCommand : boolean;
    HasPrefix        : boolean;
    NameIsServer     : boolean;
  end;
  // Bot procedure call
  TBotsndMsgProc = procedure(cMsg : PChar; IRCBotMessage : PIRCBotMessage; SocketID:DWord); stdcall;
  // Bot Init record
  TBotIdentifyData = record
    pBotName   : PChar;
    pBotPass   : PChar;
    BotOptions : cardinal;
    Icon       : HICON;
  end;
  // Dll exported functions
  TFuncBotIdentify     = function(var BotIdentifyData:TBotIdentifyData): boolean; stdcall;
                                                                         {BotIdentify function}
  TFuncBotConnect      = function(SendMessageProc : TBotsndMsgProc;
                                  SocketID:DWord): boolean; stdcall;     {BotConnect function}
  TFuncBotMessage      = procedure(const IRCBotMessage : TIRCBotMessage;
                                   cMsg : PChar); stdcall;               {BotMessage function}
  TFuncBotDisconnect   = procedure; stdcall;                             {BotDisconnect function}
  TFuncBotFinalization = procedure; stdcall;                             {BotFinalization function}
  TFuncBotConfig       = procedure; stdcall;                             {BotConfig function}

implementation

end.
